package uebung10.logo;

public class HanselGretelVisitor implements Visitor<Void> {

    private double gap;
    private double s;
    private Turtle turtle;
    private DarkForest forest;
    private State state;

    public HanselGretelVisitor(double s, Turtle turtle, DarkForest forest) {
        this.s = s;
        this.turtle = turtle;
        this.forest = forest;
    }

    @Override
    public Void visit(PenUp penUp) {
        up();
        return null;
    }

    @Override
    public Void visit(PenDown penDown) {
        down();
        return null;
    }

    @Override
    public Void visit(Turn turn) {
        turtle.turn(turn.angle);
        return null;
    }

    @Override
    public Void visit(Sequence sequence) {
        for(Stmt elem :sequence.seq) {
            elem.accept(this);
        }
        return null;
    }

    @Override
    public Void visit(Go go) {
        go(go.dist);
        return null;
    }

    private void breadCrumb() {
        forest.breadCrumb(turtle.getX(), turtle.getY());
    }

    private void layTrail(double d) {
        // TODO Auto-generated method stub
        throw new UnsupportedOperationException("Unimplemented method 'layTrail'");
    }

    private abstract class State {
        abstract void go(double dist);
        abstract void up();
        abstract void down();
        }

    private final State longUpState = new State(){

        @Override
        void go(double d) {turtle.go(d);}

        @Override
        void down(){
            breadCrumb();
            state = downState;
        }

        @Override
        void up() {}

    };

    private final State downState = new State(){

        @Override
        void go(double d){
            layTrail(d);
        }

        @Override
        void up(){state = shortUpState;}

        @Override
        void down() {}
    };

    private final State shortUpState = new  State() {

        @Override
        void go(double dist) {
            turtle.go(dist);
            gap = gap + dist;

            if (gap < s) {

            } else {
                gap = 0;
                state = longUpState;
            }
        }

        @Override
        void up() {}

        @Override
        void down() {
            state = downState;
        }

    };


    private void go(double d) {
        state.go(d);
    }

    private void down() {
        state.down();
    }

    private void up() {
        state.up();
    }
}
